# -*- coding:utf-8 -*-
"""
@author: yq
@time: 2024/1/2
@desc: 指标计算基类
"""
import abc

import pandas as pd

from entitys import MetricFucEntity


class MetricBase(metaclass=abc.ABCMeta):

    @abc.abstractmethod
    def validate_data(self):
        pass

    @abc.abstractmethod
    def load_data(self, *args, **kwargs) -> pd.DataFrame:
        pass

    @abc.abstractmethod
    def calculate(self, *args, **kwargs) -> MetricFucEntity:
        pass
